<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: Calendar
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

class Calendar
{

	function Output()
	{
		$date = time();

		$day = date('d', $date);
		$month = date('m', $date);
		$year = date('Y', $date);

		// Get the first day of month 1-7 (i.e. 5 means friday was first day of month);
		$first_day = mktime(0,0,0,$month, 1, $year); 
		$fd = date('N', $first_day); 

		// Just declare some variable
		$Done = 1;
		$days = date('t', $date);
		$Return = null;
		$Found = false;

		foreach(range(1, 45) as $d)
		{
			// If we've done it all, exit out of the loop
			if($Done == ($days + 1)) break;

			if((int) $d == (int) date("d"))
				$Return .= "<li><a href='#' class='event'>" . $Done . "</a></li>\n";
			else
				$Return .= "<li><a href=\"#\">" . $Done . "</a></li>\n";

			$Done++;

		}

		// How many days are left?
		$tmp = $fd + $days -1;
		while($tmp >= 7) $tmp -= 7;

		$DaysInMo = cal_days_in_month(CAL_GREGORIAN, date("m"), date("Y"));
		switch( $DaysInMo ) {
			case 31:
				$Left = 4;
				break;
			case 30: 
				$Left = 5;
				break;
			case 29:
				$Left = 6;
				break;
			case 28:
				$Left = 0;
				break;
			default:
				$Left = 0;
				break;
		}
		
		// Finish up the calendar with blank days
		if($Left > 0)
			for( $x = 0; $x < $Left; $x++ )
				$Return .= "<li><span></span></li>\n";

		return $Return;

	}

}