<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: Index
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

class Index
{

	var $Settings;
	var $class;

	function auto_run()
	{
		switch($this->class->main->Data("do"))
		{
			case 'config':
				return $this->config();
				break;
			case 'submit_settings':
				return $this->Update('?act=main&do=config');
				break;
			case 'seo':
				return $this->seo_settings();
				break;
			case 'submit_seo':
				$this->Update();
				break;
			case 'advertisements':
				return $this->advertisements();
				break;
			case 'submit_ads':
				return $this->Update('?act=main&do=advertisements');
				break;
			case 'partners':
				return $this->partners();
				break;
			case 'delete_partners':
				return $this->delete_partners();
				break;
			case 'new_partner':
				return $this->new_partner();
				break;
			case 'create_partner':
				return $this->create_partner();
				break;
			case 'edit_partner':
				return $this->edit_partner();
				break;
			case 'do_edit_partner':
				return $this->do_edit_partner();
				break;
			case 'admins':
				return $this->admins();
				break;
			case 'new_admin':
				return $this->new_admin();
				break;
			case 'do_admin':
				return $this->do_admin();
				break;
			case 'make_admin':
				return $this->make_admin();
				break;
			case 'demote_user':
				return $this->demote_user();
				break;
			default:
				return $this->logged_in_page();
				break;
		}
	}
		

	//-----------------------------------------------
	// View the logged in page
	//-----------------------------------------------

	function logged_in_page() 
	{

		global $Replace;
		global $Admin;
		global $functions;

		$Replace['title'] = 'Admin home';

		$Query="SELECT * FROM `".PREFIX."settings`";
		$Result=mysql_query($Query) or die(mysql_error());

		while ($Row = mysql_fetch_assoc($Result))
			$this->Settings[$Row['identifier']]=$Row['value'];

		//---------------------------------------
		// Get the details
		//---------------------------------------

		$replaceVariables=array();

		$replaceVariables['version'] = VERSION;				    #Installed version

		$html = null;

		$replaceVariables['username']=$Admin->Admin['username'];
		
		// Grab the dashboard
		$Dashboard = Functions::LoadTemplate("dashboard", array());
		$html .= Functions::BuildSection("Dashboard", $Dashboard);

		return $html;
	}

	function config()
	{
		// Variables
		$Return = null;

		// Settings array
		$Settings = $this->class->main->Settings;

		// Homepage settings
		$Html = Functions::LoadTemplate("settings/homepage", $Settings);
		$Return .= Functions::BuildSection( 'Website Settings', $Html );

		// Wallpaper settings
		$Html = Functions::LoadTemplate("settings/wallpapers.html", $Settings);
		$Return .= Functions::BuildSection( 'Wallpaper Settings', $Html );

		// Category settings
		$Html = Functions::LoadTemplate("settings/categories", $Settings);
		$Return .= Functions::BuildSection( 'Category Settings', $Html );

		// Users settings
		$Html = Functions::LoadTemplate("settings/users", $Settings);
		$Return .= Functions::BuildSection( 'Member Settings', $Html );

		// Misc settings
		$Html = Functions::LoadTemplate("settings/misc", $Settings);
		$Return .= Functions::BuildSection( 'Misc Settings', $Html );

		$Return .= Functions::LoadTemplate("settings/submit");

		// Wrap it up in a form
		$Return = Functions::LoadTemplate("form", array(
			'action' => '?act=main&do=submit_settings', 
			'method' => 'post', 
			'id' => '', 
			'class' => 'search_form general_form',
			'content' => $Return,
		));


		return $Return;



	}


	function seo_settings()
	{
		$Return = null;

		// Settings array
		$Settings = $this->class->main->Settings;

		// Homepage settings
		$Html = Functions::LoadTemplate("settings/seo", $Settings);
		$Return .= Functions::BuildSection( 'SEO Settings', $Html );

		// Wrap it up in a form
		$Return = Functions::LoadTemplate("form", array(
			'action' => '?act=main&do=submit_seo', 
			'method' => 'post', 
			'id' => '', 
			'class' => 'search_form general_form',
			'content' => $Return,
		));

		return $Return;
	}

	function advertisements()
	{
		$Return = null;

		// Settings array
		$Settings = $this->class->main->Settings;

		// Homepage settings
		$Html = Functions::LoadTemplate("settings/adslots", $Settings);
		$Return .= Functions::BuildSection( 'Advertisements Settings', $Html );

		// Wrap it up in a form
		$Return = Functions::LoadTemplate("form", array(
			'action' => '?act=main&do=submit_ads', 
			'method' => 'post', 
			'id' => '', 
			'class' => 'search_form general_form',
			'content' => $Return,
		));

		return $Return;
	}

	function Update($Redirect = '?act=main&do=seo', $Message = 'Your settings have been updated.')
	{
		Functions::DemoCheck();

		$Queries = array();
		foreach($_POST as $Name => $Val)
		{
			// Only run query if it's changed.
			if($this->class->main->Settings[$Name] != $Val)
				$Queries[] = "UPDATE `settings` SET `value` = '" . $this->class->main->Data($Name) . "' WHERE `identifier` = '" . addslashes($Name) . "'";
		}

		foreach($Queries as $Query)
			$this->class->main->mysql->Query($Query);

		Functions::Redirect($Message , $Redirect);
	}

	function Partners()
	{
		// Table content
		$tbl = Functions::LoadTemplate("table_wrapper", array());
		$tbl .= Functions::LoadTemplate("wrapper_partner_table_start", array());

		$Query = "SELECT * FROM `partners` ORDER BY `id` DESC";
		$Result = $this->class->main->mysql->Query($Query);
		$Partners = $this->class->main->mysql->FetchResults($Result);
	
		foreach($Partners as $Partner)
		{
			$tbl .= Functions::LoadTemplate("wrapper_partner_entry", $Partner);

		}

		// Finish up the table
		$tbl .= Functions::LoadTemplate("wallpaper_table_end", array());
		$tbl .= Functions::LoadTemplate("table_wrapper_end", array());
		$tbl .= Functions::LoadTemplate("table_partner_options", array());

		// Wrap it up in a form
		$form = Functions::LoadTemplate("form", array('action' => '?act=main&do=delete_partners', 'method' => 'post', 'id' => 'cats_form', 'content' => $tbl));

		// Build it from the template
		$Section = Functions::BuildSection("Manage Partners", $form, array('table' => 1));

		return $Section;

	}

	function delete_partners()
	{
		Functions::DemoCheck();

		$Partners = $_REQUEST['partners'];

		if (! is_array($Partners) || count($Partners) == 0)
			Functions::AdminError("You must select some partner links to delete.");
		
		// Go through wallpapers we want to delete.
		foreach($Partners as $id)
		{
			$Id = addslashes($id);
			if ($Id != null)
			{
				// Retrieve the wallpaper details
				$Query = "DELETE FROM `partners` WHERE `id`= '".$Id . "'";
				$Result = $this->class->main->mysql->Query($Query);
			}
		}
	
		// All wallpapers deleted. Let's redirect.
		Functions::Redirect('Your partner link(s) have been deleted', 'index.php?act=main&do=partners');
	}

	function new_partner()
	{
		// Build output data
		$Content = Functions::LoadTemplate("new_partner", array('name' => '', 'anchor' => '', 'url' => '', 'description' => ''));
		$Content = Functions::LoadTemplate("form", array("action" => '?act=main&do=create_partner', 'method' => 'post', 'content' => $Content, 'id' => 'delete_confirmation', 'class' => 'search_form general_form'));
		$HTML = Functions::BuildSection('Add New Partner', $Content);

		return $HTML;
	}

	function create_partner()
	{
		Functions::DemoCheck();

		if($this->class->main->Data("name") == null)
			Functions::AdminError("You must enter a partner name.");

		if($this->class->main->Data("anchor") == null)
			Functions::AdminError("You must enter anchor text.");

		if($this->class->main->Data("url") == null)
			Functions::AdminError("You must enter a url.");

		if($this->class->main->Data("description") == null)
			Functions::AdminError("You must enter a wallpaper description.");

		// No more errors, let's create the category.
		$Query = "INSERT INTO `partners` (`name`, `anchor`, `url`, `description`) VALUES('" . $this->class->main->Data("name") . "', '" . $this->class->main->Data("anchor") . "', '" . $this->class->main->Data("url") . "', '" . $this->class->main->Data("description") . "')";
		$Result = $this->class->main->mysql->Query($Query);

		// No errors, lets redirect.
		Functions::Redirect( "Partner '" . $this->class->main->Data("name") . "' has been created.", 'index.php?act=main&do=partners' );

	}

	function edit_partner()
	{
		// Grab the categories
		$Query = "SELECT * FROM `partners` WHERE `id` = " . $this->class->main->Data("id");
		$Result = $this->class->main->mysql->Query($Query);
		$Partner = $this->class->main->mysql->FetchResults($Result);

		if(!isset($Partner[0]))
			Functions::AdminError("Partner id not found.");

		$Partner = $Partner[0];

		// Build output data
		$Content = Functions::LoadTemplate("new_partner", $Partner);
		$Content = Functions::LoadTemplate("form", array("action" => '?act=main&do=do_edit_partner', 'method' => 'post', 'content' => $Content, 'id' => 'delete_confirmation', 'class' => 'search_form general_form'));
		$HTML = Functions::BuildSection('Edit Partner', $Content);

		return $HTML;

	}

	function do_edit_partner()
	{
		Functions::DemoCheck();

		if($this->class->main->Data("id") == null)
			Functions::AdminError("You must enter an id.");

		$Query = "SELECT * FROM `partners` WHERE `id` = " . $this->class->main->Data("id");
		$Result = $this->class->main->mysql->Query($Query);
		$Partner = $this->class->main->mysql->FetchResults($Result);

		if(!isset($Partner[0]))
			Functions::AdminError("Partner id not found.");

		if($this->class->main->Data("name") == null)
			Functions::AdminError("You must enter a partner name.");

		if($this->class->main->Data("anchor") == null)
			Functions::AdminError("You must enter anchor text.");

		if($this->class->main->Data("url") == null)
			Functions::AdminError("You must enter a url.");

		if($this->class->main->Data("description") == null)
			Functions::AdminError("You must enter a wallpaper description.");
	
		// Run the query
		$Query = "UPDATE `partners` SET `name` = '" . $this->class->main->Data("name") . "', `anchor` = '" . $this->class->main->Data("anchor") . "', `url` = '" . $this->class->main->Data("url") . "', `description`='" .$this->class->main->Data("description") . "' WHERE `id` = '" . $this->class->main->Data("id") . "'";
		$Result = $this->class->main->mysql->Query($Query);

		// No errors, lets redirect.
		Functions::Redirect( "Partner '" . $this->class->main->Data("name") . "' has been edited.", 'index.php?act=main&do=partners' );


	}

	function admins()
	{
		// Table content
		$tbl = Functions::LoadTemplate("table_wrapper", array());
		$tbl .= Functions::LoadTemplate("wrapper_admin_table_start", array());

		$Query = "SELECT * FROM `users` WHERE `admin` = 1 ORDER BY `name` ASC";
		$Result = $this->class->main->mysql->Query($Query);
		$Admins = $this->class->main->mysql->FetchResults($Result);
	
		foreach($Admins as $Admin)
		{
			$Arr = array(
				'name'		=> $Admin['username'],
				'id'		=> $Admin['userid'],
				'anchor'	=> $Admin['email'],
				'url'		=> $Admin['name'],
			);
			$tbl .= Functions::LoadTemplate("wrapper_admin_entry", $Arr);

		}

		// Finish up the table
		$tbl .= Functions::LoadTemplate("wallpaper_table_end", array());
		$tbl .= Functions::LoadTemplate("table_wrapper_end", array());
		$tbl .= Functions::LoadTemplate("table_admin_options", array());

		// Build it from the template
		$Section = Functions::BuildSection("Manage Admins", $tbl, array('table' => 1));

		return $Section;


	}

	function new_admin()
	{
		$Output = Functions::LoadTemplate("search_user");


		// Wrap it up in a form
		$Output = Functions::LoadTemplate("form", array(
			'action' => '?act=main&do=make_admin', 
			'method' => 'post', 
			'id' => '', 
			'class' => 'search_form general_form',
			'content' => $Output,
		));

		$Output = Functions::BuildSection("Add Admin", $Output);

		return $Output;

	}

	function do_admin()
	{
		$Admin = $this->class->main->Data("username");

		if($Admin == null)
			die("No username entered.");

		$Query = "SELECT * FROM `users` WHERE `username` = '".$Admin . "'";
		$Result = $this->class->main->mysql->Query($Query);
		$Admin = $this->class->main->mysql->FetchResults($Result);

		if(! isset($Admin[0]) || count($Admin[0]) == 0)
			die("Username does not exist.");

		$Admin[0]['gender'] = $Admin[0]['gender'] == 1 ? '<span style="color:blue;">Male</span>' : '<span style="color:#ff0066;">Female</span>';

		$Output = Functions::LoadTemplate( "admin_details", $Admin[0] );

		echo $Output;
		exit;

	}

	function make_admin()
	{
		Functions::DemoCheck();

		$Id = $this->class->main->Data("id");

		if($Id == null)
			Functions::AdminError("You must enter an id.");

		$Query = "SELECT COUNT(*), `username` FROM `users` WHERE `userid` = '" . $Id . "'";
		$Result = $this->class->main->mysql->Query($Query);
		$User = $this->class->main->mysql->FetchResults($Result);
		$User = $User[0];

		if($User['COUNT(*)'] == 0)
			Functions::AdminError("User does not exist.");

		$Query = "UPDATE `users` SET `admin` = 1 WHERE `userid` = '" . $Id . "'";
		$Result = $this->class->main->mysql->Query($Query);

		Functions::Redirect( "User '" . $User['username'] . "' has been promoted to admin", 'index.php?act=main&do=admins' );
	}

	function demote_user()
	{
		Functions::DemoCheck();

		$Id = $this->class->main->Data("u");

		if($Id == null)
			Functions::AdminError("You must enter an id.");

		$Query = "SELECT COUNT(*), `username` FROM `users` WHERE `userid` = '" . $Id . "'";
		$Result = $this->class->main->mysql->Query($Query);
		$User = $this->class->main->mysql->FetchResults($Result);
		$User = $User[0];

		if($User['COUNT(*)'] == 0)
			Functions::AdminError("User does not exist.");

		$Query = "UPDATE `users` SET `admin` = 0 WHERE `userid` = '" . $Id . "'";
		$Result = $this->class->main->mysql->Query($Query);

		Functions::Redirect( "User '" . $User['username'] . "' has been demoted", 'index.php?act=main&do=admins' );
	}


}


?>