<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: functions
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

class functions
{

	static $class;

	// Build categories function
	public static function build_categories($return = array())
	{
		$html = null;
		$html .= functions::$class->template->LoadTemplate("global/boxthin_left.cphp", $return);
		$html .= functions::$class->CompileCategories();
		$html .= functions::$class->CompilePartners();
		$html .= functions::$class->template->LoadTemplate("global/cats_end.cphp", $return);

		return $html;
	}

	public static function rewrite_arr($Rewrite)
	{
		$Pattern = "/(\n|\r\n)/";
		$Arr = preg_split($Pattern, $Rewrite);
		
		$Ret = array();
		foreach($Arr as $Rew)
		{
			if( strpos( $Rew, '=>' ) <> 0 )
			{
				$Rew = str_replace(' =>', '=>', $Rew);
				$Rew = str_replace('=> ', '=>', $Rew);

				$tmp = explode('=>', $Rew);
				$Ret[] = $tmp;
			}
		}

		return $Ret;
	}

	public static function sift_plugins($Arr)
	{
		$Return = array();

		foreach($Arr as $Level => $Plugin)
		{
			foreach($Plugin as $Details)
			{
				if( empty($Details['template']) )
					$Details['template'] = '*';

				$Return[$Details['template']][] = $Details;
			}
		}

		return $Return;
	}

	// Send an email
	public static function send_mail($to, $subject, $message, $from)
	{
		$headers = 'From: ' . $from . "\r\n" .
			'Reply-To: ' . $from . "\r\n" .
			'X-Mailer: PHP/' . phpversion();

		mail($to, $subject, $message, $headers);
	}

	// Current mysql version

	public static function cur_url()
	{
		$Url = null;

		$Host = $_SERVER['HTTP_HOST'];
		if(substr($Host, -1) == '/') $Host .= substr($Host, 0, strlen($Host) - 1);

		$Script = $_SERVER['SCRIPT_NAME'];
		$Script = preg_replace("/([a-zA-Z0-9]+)\.([a-zA-Z0-9]+)/", null, $Script);

		$Url = 'http://' . $Host . $Script;

		return $Url;
	}


	// Fetch the images from a directory
	public static function fetch_images($dir)
	{
		$return = array();
		$allowed = array("jpg", "jpeg", "png", "gif", "bmp");

		$dir .= substr($dir, -1) != "/" ? "/" : null;
		$emot = '';

		if (is_dir($dir))
		{
			if($d_handle = opendir($dir))
			{
				while (($file = readdir($d_handle)) !== false) {
					if (strtolower(filetype($dir . $file)) == 'file') 
					{
						$val = substr($file,strrpos($file,".")+1);
						if(in_array($val, $allowed))
							$return[] = $file;
					}
				}
				closedir($d_handle);
			} else return array();
		} else return array();

		return $return;

	}

	//---------------------------------------
	// Remove the curse words
	//---------------------------------------

	public static function RemoveCurseWords($Comment,$Curse)
	{
		$words = explode(",",$Curse);
		foreach($words as $val)
		{
			$replace = null;
			for($x = 0; $x < strlen($val); $x++)
				$replace .= "*";
			$Comment = str_ireplace($val, $replace, $Comment);
		}
		return $Comment;
	}

	//-----------------------------------------------------------
	// Find how long ago (for the comments)
	//-----------------------------------------------------------

	public static function TimeAgo($time,$complete=false)
	{
		$dif = time() - $time;

		$Years = 60 * 60 * 24 * 365.25;
		$Months = 60 * 60 * 24 * 30.4375;
		$Days = 60 * 60 * 24;
		$Hours = 60 * 60;
		$Minutes = 60;
		$Seconds = 1;

		$Ago = array(
			"years"		=> floor($dif/$Years),
			"months"	=> floor($dif/$Months),
			"days"		=> floor($dif/$Days),
			"hours"		=> floor($dif/$Hours),
			"minutes"	=> floor($dif/$Minutes),
			"seconds"	=> floor($dif/$Seconds),
		);

		if ($complete == true)
			return $Ago;

		foreach($Ago as $type => $val)
			if ($val != 0) break;

		$type = ($val == 1) ? substr($type,0,strlen($type)-1) : $type;
		return array($val,$type);
	}

	public static function str_contains($haystack, $needle, $sensitive = false)
	{
		if($sensitive == false)	return strpos($haystack, $needle) == 0 ? false : true;
		else return stripos($haystack, $needle) == 0 ? false : true;
	}

	
	public static function GetStringBetween($string,$start,$end)
	{ 
		if (! functions::str_contains($string, $start) || ! functions::str_contains($string, $end))
			return false;

		$strStart = strpos($string,$start) + strlen($start); 
		$string2=substr($string,$strStart);
		$strEnd = strpos($string2,$end); 
		$strTemp = substr($string2,$strEnd);
		$string=str_replace($strTemp,null,$string);

		return substr($string,$strStart,$strEnd); 
	} 

	public static function check_perms($username,$password)
	{
        $username = addslashes($username);
        $password = addslashes($password);
        
		$query = "SELECT COUNT(*) FROM `".PREFIX."users` WHERE (`email`='$username' OR `username`='$username') AND `password`='$password'";
		$result = mysql_query($query) or die(mysql_error());
		$row = mysql_fetch_assoc($result);
		if($row['COUNT(*)'] >= 1) 
			return true;
		else return false;
	}

	public static function check_logged()
	{
		if (isset($_COOKIE['username']) && isset($_COOKIE['password']))
		{
			if (functions::check_perms($_COOKIE['username'], $_COOKIE['password']) == true)
				return true;
			else return false;
		} else
			return false;

		if ($error) 
			return $error; exit;
	}
	
	public static function check_login($username, $password, $remember=1)
	{
		$return = array();

		$username = addslashes($username);
		$password = addslashes($password);

		$md5_pass = null;

		$error = null;

		if (! $password || ! $username)
			$error = "Must enter username and password";

		if (! $error)
		{
			$md5_pass = md5($password);

			$query = "SELECT `email`, COUNT(*) FROM `".PREFIX."users` WHERE (`email`='$username' OR `username`='$username') AND `password`='$md5_pass' GROUP BY email";

			$result = mysql_query($query) or die(mysql_error());
			$res = mysql_fetch_assoc($result);

			if(intval($res['COUNT(*)']) >= 1)
			{
				setcookie('username', $res['email'], time() + (intval($remember)*3600), "/");
				setcookie('password', $md5_pass, time() + (intval($remember)*3600), "/");
			} else
				$error = "Incorrect username or password.";
		}

		if ($error) 
		{ 
			$return['result'] = false;
			$return['error'] = $error;
			$Success = 0;
		} else 
		{
			$return['result'] = true;
			$Success = 1;
		}

		$Query = "INSERT INTO `login_attempts` (`username`, `password`, `ip`, `time`, `admin`, `success`) ";
		$Query .= "VALUES('$username', '$md5_pass', '" . addslashes($_SERVER['REMOTE_ADDR']) . "', " . time()  . ", 0, $Success);";

		mysql_query($Query) or die(mysql_error());

		return $return;
	}

	public static function resizeImage($file,$filename,$newwidth=160,$newheight=120)
	{
		$type = substr($file,strrpos($file,".")+1);

		switch($type) 
		{
			case 'jpg':
				$src = imagecreatefromjpeg($file);
				break;
			case 'jpeg':
				$src = imagecreatefromjpeg($file);
				break;
			case 'gif':
				$src = imagecreatefromgif($file);
				break;
			case 'png':
				$src = imagecreatefrompng($file);
				break;
			default:
				$src = imagecreatefromjpeg($file);
				break;
		}

		list($width,$height)=getimagesize($file);
		$tmp=imagecreatetruecolor($newwidth,$newheight);
		imagecopyresampled($tmp,$src,0,0,0,0,$newwidth,$newheight,$width,$height);

		switch($type) {
			case 'jpg':
				imagejpeg($tmp,$filename,100);
				break;
			case 'jpeg':
				imagejpeg($tmp,$filename,100);
				break;
			case 'gif':
				imagegif($tmp,$filename,100);
				break;
			case 'png':
				imagepng($tmp,$filename,9);
				break;
			case 'wbm':
				imagewbmp($tmp,$filename,100);
				break;
			default:
				imagejpeg($tmp,$filename,100);
				break;
		}
		imagedestroy($src);
		imagedestroy($tmp);
		return true;
	}

	public static function Countries($html = false,$selCountry = null)
	{
		$Countries = array('Afghanistan', 'Albania', 'Algeria', 'American Samoa', 'Andorra', 'Angola', 'Anguilla', 'Antarctica', 'Antigua/Barbuda', 'Argentina', 'Armenia', 'Aruba', 'Australia', 'Austria', 'Azerbaijan', 'Bahamas', 'Bahrain', 'Bangladesh', 'Barbados', 'Belarus', 'Belgium', 'Belize', 'Benin', 'Bermuda', 'Bhutan', 'Bolivia', 'Bosnia/Herzegovina', 'Botswana', 'Bouvet Island', 'Brazil', 'British Indian Ocean Territory', 'Brunei Darussalam', 'Bulgaria', 'Burkina Faso', 'Burundi', 'Cambodia', 'Cameroon', 'Canada', 'Cape Verde', 'Cayman Islands', 'Central African Republic', 'Chad', 'Channel Islands', 'Chile', 'China', 'Christmas Island', 'Cocos (Keeling) Islands', 'Colombia', 'Comoros', 'Congo', 'Cook Islands', 'Costa Rica', 'Croatia (Hrvatska)', 'Cuba', 'Cyprus', 'Czech Republic', 'Denmark', 'Djibouti', 'Dominica', 'Dominican Republic', 'East Timor', 'Ecuador', 'Egypt', 'El Salvador', 'England', 'Equatorial Guinea', 'Eritrea', 'Estonia', 'Ethiopia', 'Falkland Islands (Malvinas)', 'Faroe Islands', 'Fiji', 'Finland', 'France', 'France, Metropolitan', 'French Guiana', 'French Polynesia', 'French Southern Territories', 'Gabon', 'Gambia', 'Georgia', 'Germany', 'Ghana', 'Gibraltar', 'Great Britain', 'Greece', 'Greenland', 'Grenada', 'Guadeloupe', 'Guam', 'Guatemala', 'Guinea', 'Guinea-Bissau', 'Guyana', 'Haiti', 'Heard/McDonald Islands', 'Honduras', 'Hong Kong', 'Hungary', 'Iceland', 'India', 'Indonesia', 'Iran', 'Iraq', 'Ireland', 'Isle of Man', 'Israel', 'Italy', 'Jamaica', 'Japan', 'Jordan', 'Kazakhstan', 'Kenya', 'Kiribati', 'Korea (North)', 'Korea (South)', 'Kuwait', 'Kyrgyzstan', 'Laos', 'Latvia', 'Lebanon', 'Liberia', 'Libya', 'Liechtenstein', 'Lithuania', 'Luxembourg', 'Macau', 'Macedonia', 'Madagascar', 'Malawi', 'Malaysia', 'Maldives', 'Mali', 'Malta', 'Marshall Islands', 'Martinique', 'Mauritania', 'Mauritius', 'Mayotte', 'Mexico', 'Micronesia', 'Moldova', 'Monaco', 'Mongolia', 'Montserrat', 'Morocco', 'Mozambique', 'Myanmar', 'Namibia', 'Nauru', 'Nepal', 'Netherlands', 'Netherlands Antilles', 'New Caledonia', 'New Zealand', 'Nicaragua', 'Niger', 'Nigeria', 'Niue', 'Norfolk Island', 'Northern Ireland', 'Northern Mariana Islands', 'Norway', 'Oman', 'Pakistan', 'Palau', 'Panama', 'Papua New Guinea', 'Paraguay', 'Peru', 'Philippines', 'Pitcairn', 'Poland', 'Portugal', 'Puerto Rico', 'Qatar', 'Reunion', 'Romania', 'Russian Federation', 'Rwanda', 'S. Georgia/S. Sandwich Isls.', 'Saint Kitts/Nevis', 'Saint Lucia', 'Saint Vincent/Grenadines', 'San Marino', 'Sao Tome/Principe', 'Saudi Arabia', 'Scotland', 'Senegal', 'Seychelles', 'Sierra Leone', 'Singapore', 'Slovak Republic', 'Slovenia', 'Solomon Islands', 'Somalia', 'South Africa', 'Spain', 'Sri Lanka', 'St. Helena', 'St. Pierre/Miquelon', 'Sudan', 'Suriname', 'Svalbard/Jan Mayen Islands', 'Swaziland', 'Sweden', 'Switzerland', 'Syria', 'Taiwan', 'Tajikistan', 'Tanzania', 'Thailand', 'Togo', 'Tokelau', 'Tonga', 'Trinidad/Tobago', 'Tunisia', 'Turkey', 'Turkmenistan', 'Turks/Caicos Islands', 'Tuvalu', 'US Minor Outlying Islands', 'Uganda', 'Ukraine', 'United Arab Emirates', 'United Kingdom', 'United States', 'Uruguay', 'Uzbekistan', 'Vanuatu', 'Vatican City State (Holy See)', 'Venezuela', 'Viet Nam', 'Virgin Islands', 'Virgin Islands', 'Wake Island', 'Wales', 'Wallis/Futuna Islands', 'Western Sahara', 'Western Samoa', 'Yemen', 'Zaire', 'Zambia', 'Zimbabwe');

		if($html == false) return $Countries;

		$ret = null;
		foreach($Countries as $Country) 
		{
			$ext = (strtolower($Country) == strtolower($selCountry)) ? " SELECTED" : null;
			$ret .= '<option value="'.$Country.'"'.$ext.'>'.$Country.'</option>';
		}

		return $ret;

	}

	public static function pagHTML($Page,$Pages,$ext,$prefix="login/pag_",$onclick="LoadWallpapers")
	{
		$pagHTML = null;
		if ($Page == 1)
		{
			//---------------------------------------------
			// We chose the first page
			//---------------------------------------------

			if($Pages == 1)
			{
				$pagHTML = functions::$class->template->LoadTemplate($prefix."selpage.cphp", array("page" => 1, "ext" => $ext, "onclick" => $onclick));
			} elseif ($Pages == 2 || $Pages == 3)
			{
				$pagHTML = functions::$class->template->LoadTemplate($prefix."selpage.cphp", array("page" => 1, "ext" => $ext, "onclick" => $onclick));
				for($x = 2; $x <= $Pages; $x++)
					$pagHTML .= functions::$class->template->LoadTemplate($prefix."page.cphp", array("page" => $x, "ext" => $ext, "onclick" => $onclick));
			} elseif ($Pages > 3)
			{
				$pagHTML = functions::$class->template->LoadTemplate($prefix."selpage.cphp", array("page" => 1, "ext" => $ext, "onclick" => $onclick));
				for($x = 2; $x <= 3; $x++)
					$pagHTML .= functions::$class->template->LoadTemplate($prefix."page.cphp", array("page" => $x, "ext" => $ext, "onclick" => $onclick));
				$pagHTML .= functions::$class->template->LoadTemplate($prefix."morepages.cphp", array());
			}
			//---------------------------------------------
			// Prev/next - we only need next
			//---------------------------------------------

			if ($Pages > 1)
				$PrevNext = functions::$class->template->LoadTemplate($prefix."next.cphp", array("next" => $Page + 1, "ext" => $ext, "onclick" => $onclick));
			else
				$PrevNext = '&nbsp;';
		} elseif ($Page == $Pages)
		{
			if ($Pages == 2)
			{
				//-------------------------------------------------
				// If there are only 2 pages, and we clicked the second.
				//-------------------------------------------------

				$pagHTML = functions::$class->template->LoadTemplate($prefix."page.cphp", array("page" => 1, "ext" => $ext, "onclick" => $onclick));
				$pagHTML .= functions::$class->template->LoadTemplate($prefix."selpage.cphp", array("page" => 2, "ext" => $ext, "onclick" => $onclick));
			} else if ($Pages >= 3)
			{
				//-------------------------------------------------
				// If there are 3 or more pages, and we clicked the last.
				//-------------------------------------------------

				$strt = $Page - 2;
				for($x = $strt; $x <= ($strt+1); $x++)
					$pagHTML .= functions::$class->template->LoadTemplate($prefix."page.cphp", array("page" => $x, "ext" => $ext, "onclick" => $onclick));

				$pagHTML .= functions::$class->template->LoadTemplate($prefix."selpage.cphp", array("page" => $Page, "ext" => $ext, "onclick" => $onclick));
			}
			//-------------------------------------------------
			// Prev/next - we only need previous.
			//-------------------------------------------------

			$PrevNext = functions::$class->template->LoadTemplate($prefix."previous.cphp", array("previous" => $Page - 1, "ext" => $ext, "onclick" => $onclick));
		} else
		{
			//-------------------------------------------------
			// If we did not click the first or last. there is always one in between.
			//-------------------------------------------------

			if (($Page - 1) >= 2) {
				// Display newest
				$pagHTML .= functions::$class->template->LoadTemplate($prefix."newest.cphp", array("onclick" => $onclick, "ext" => $ext));
			}

			$pagHTML .= functions::$class->template->LoadTemplate($prefix."page.cphp", array("page" => $Page-1, "ext" => $ext, "onclick" => $onclick));
			$pagHTML .= functions::$class->template->LoadTemplate($prefix."selpage.cphp", array("page" => $Page, "ext" => $ext, "onclick" => $onclick));
			$pagHTML .= functions::$class->template->LoadTemplate($prefix."page.cphp", array("page" => $Page+1, "ext" => $ext, "onclick" => $onclick));
			if($Page + 1 != $Pages)
				$pagHTML .= functions::$class->template->LoadTemplate($prefix."morepages.cphp", array());
			// Prev/next - we need both next and previous
			$PrevNext = functions::$class->template->LoadTemplate($prefix."prevnext.cphp", array(
				"next" => ($Page + 1), "previous" => ($Page - 1), "ext" => $ext, "onclick" => $onclick));
		}
		
		$tmp = substr($prefix, strrpos($prefix, "/")+1, strlen($prefix));
		$pre = str_replace($tmp, null, $prefix);
		$replace = array("pages"=> $pagHTML, "prevnext"=>$PrevNext, "onclick" => $onclick);
		$paghtml = functions::$class->template->LoadTemplate($pre."paghtml.cphp", $replace);

		return $paghtml;

	}

	public static function format_message($msg,$short=false,$path=null)
	{

		$Message = $msg;

		//---------------------------------------
		// Let's get the smilies
		//---------------------------------------

		$dir = "images/smilies/";
		$emot = '';
		if (is_dir($dir))
		{
			if($d_handle = opendir("images/smilies/"))
			{
				while (($file = readdir($d_handle)) !== false) {
					if (strtolower(filetype($dir . $file)) == 'file') 
					{
						$val = str_replace(substr($file,strrpos($file,".")),null,$file);
						if($short == false)
							$Message = str_replace("[".$val."]","[img]".$path.$dir.$file."[/img]",$Message);
						else $Message = str_replace("[".$val."]",null,$Message);
					}
				}
				closedir($d_handle);
			}
		}

		// Remove html entities
		#$Message = htmlspecialchars($Message);

		// New lines
		$Replace = ($short == false) ? '<br />' : ' ';
		$Message = str_replace(array("\r\n","\n","\r"), $Replace, $Message);

		// BBcode
		$Message = preg_replace('/\[url=\'(.*?)\'\](.*?)\[\/url\]/', '<a href="$1">$2</a>', $Message); // Link
		$Message = preg_replace('/\[img\](.*?)\[\/img\]/', '<img src="$1" alt="Image" />', $Message); // Image

		// Remove curse words
		$Message = functions::RemoveCurseWords($Message, functions::$class->Settings['curse_words']);
		
		return $Message;

	}

	public static function ReplaceLinks($str)
	{

		if(functions::$class->Settings['replace_non_english'] == '1')
		{
			preg_match_all("/href\=[\'\\\"](.*?)\.(\w+)[\'\\\"]/", $str, $res);

			$res[1] = array_map("functions::ReplaceMultiple", $res[1]);
			$res[0] = array_map("functions::ReplaceMultipleOne", $res[0]);

			foreach($res[1] as $id => $link)
			{
				$Link = utf8_encode($link);
				$Ext = strrpos($res[0][$id], ".");

				if($Ext != 0)
				{
					$Ext = substr($res[0][$id], $Ext + 1, strlen($res[0][$id]));
					$Ext = '.' . str_replace(array('"', "'"), null, $Ext);
				} else $Ext = null;

				$str = str_replace($res[0][$id], 'href="' . $Link .  $Ext . '"', $str);
			}
		}

		return $str;
	}

	public static function ReplaceMultiple($str)
	{
		$str = strpos($str, '"') ? str_replace(substr($str, strpos($str, '"'), strlen($str)), null, $str) : $str;
		$str = strpos($str, "'") ? str_replace(substr($str, strpos($str, "'"), strlen($str)), null, $str) : $str;

		return $str;
	}

	public static function ReplaceMultipleOne($str)
	{
		preg_match_all("/[\\\"\'](.*?)[\\\"\']/", $str, $res);
		if(count($res) > 0 || isset($res[0][1]))
			$str = 'href=' . $res[0][0];

		return $str;
	}

	public static function Path()
	{
		$Script = $_SERVER['SCRIPT_NAME'];

		$Directory = preg_replace('/\w+\.\w+/', null, $Script);

		if($Directory != '/')
			$Path = str_replace($Directory, null, $_SERVER['REQUEST_URI']);
		else $Path = $Directory;

		$Am = substr_count($Path, '/');

		$Path = null;
		for($x = 0; $x < $Am; $x++)
			$Path .= '../';

		return $Path;
	}

}