<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: n/a
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

session_start();
include_once("query.php");

//include_once("settings.php");

// Sort out the MySQL parsing string. DO NOT REMOVE THIS
$MySQL_Force = '<?php

$Installed = 1;

$MySQL = array(
    "host"      => "{host}",
    "username"  => "{username}",
    "password"  => "{password}",
    "database"  => "{database}"
    );

?>';

if (isset($_GET['act']) && $_GET['act'] == 'clear_method')
	unset($_SESSION['method']);

if (! isset($_SESSION['method']) || $_SESSION['method'] == NULL || !isset($_SESSION['method'])) 
{
	if (isset($_GET['act']) && $_GET['act'] == 'submit_method')
	{
		$choices = array(1,2,3);
		$method = addslashes($_POST['method']);

		if (!in_array($method, $choices)) 
		{
			echo LoadMethodHTML('Invalid method selected.');
			exit;
		}

		if ($method == 1)
		{
			//curl
			if (! function_exists("curl_init")) 
			{
				echo LoadMethodHTML('You do not have curl installed. Please select another method.');
				exit;
			}
		}

		$_SESSION['method'] = $method;

	} else 
	{

		$form = "<h1>WallScript Installation - Connection method</h1>\n".
				"<form action='install.php?act=submit_method' method='POST'>\n".
				"<strong>Method for connecting to URLs:</strong>\n".
				"<select name='method'>\n<option value='1'>cURL</option>\n".
				"<option value='2'>file_get_contents</option>\n".
				"<option value='3'>fsockopen</option>\n</select>\n".
				"<input type='submit' value='Submit'>\n\n<br /><br />\n\n".
				"As some servers disallow certain functions or do not have them installed, we have given ".
				"you the choice as to what method to use.";
		
		echo LoadMethodHTML($form);
		exit;
	}
}

$method = $_SESSION['method'];

//-----------------------------------------------
// Load method HTML
//-----------------------------------------------

function LoadMethodHTML($html, $title='WallScript Installation') {
	return '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
 <HEAD>
  <TITLE> '.$title.' </TITLE>
  <META NAME="Author" CONTENT="">
  <META NAME="Description" CONTENT="">
  <style type=\'text/css\'>
	@import url(method.css);
  </style>
 </HEAD>

 <BODY>
  '.$html.'
 </BODY>
</HTML>
	';
}

if (! isset($_SESSION['auth']) || $_SESSION['auth'] != true) 
{
	if (isset($_GET['act']) && $_GET['act'] == 'submit')
		SubmitAuth();

	ViewAuth();
}


function SubmitAuth() 
{

	#$_SESSION['auth'] = true;

	error_reporting(0);

	$Install = "true";
	$Product = "006";
	$Domain = $_SERVER['HTTP_HOST'];

	//------------------------------
	// Sort out the token
	//------------------------------

	$time = time();

	//------------------------------
	// Send the HTTP request
	//------------------------------

	// Server could not be found.
	if($result == null)
	{
		$_SESSION['auth'] = true;
		header("Location: install.php");
	}


	//------------------------------
	// Verify the result
	//------------------------------

	$Strong = GetStringBetween($result,"<strong>","</strong>");

	if ($Strong == "WallScript Return")
	{

		//--------------------------
		// Proper return, let's go fishing for some data.
		//--------------------------

		$Result = GetStringBetween($result,"<result>","</result>");
		$Notes = GetStringBetween($result,"<notes>","</notes>");
		$Level = GetStringBetween($result,"<level>","</level>");

		//--------------------------
		// Error or no error?
		//--------------------------


		if ($Result == "Install") 
		{
			$_SESSION['auth']=true;
			header("Location: install.php");
		}
	}
}

function OpenURL($url, $ref=null) 
{

	global $NClass;
	global $method;

	if ($method=='1') 
	{
		//Open with cURL
		$header = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)";  

		$ch = curl_init($url); 
		curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1); 
		curl_setopt($ch, CURLOPT_HEADER, 0);  
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);  
		curl_setopt($ch, CURLOPT_REFERER, $ref);
		curl_setopt($ch, CURLOPT_USERAGENT, $header); 
		$data = curl_exec ($ch); 
		curl_close ($ch);

	} elseif ($method == '2')
		$data=file_get_contents($url);

	elseif ($method=='3') 
	{
		include_once("../includes/HTTP.php");
		$HTTP = new HTTP();
		$data = $HTTP->Request("GET", $url, $ref);
	}

	return $data;
}

function GetStringBetween($string, $start, $end)
{ 
	if (! eregi($start, $string) || ! eregi($end, $string))
		return false;

	$strStart = strpos($string, $start) + strlen($start); 
	$string2 = substr($string, $strStart);
	$strEnd = strpos($string2, $end); 
	$strTemp = substr($string2, $strEnd);
	$string = str_replace($strTemp,null, $string);

	return substr($string, $strStart, $strEnd); 
} 

function ViewAuth($error=null) 
{
	if($error != null)
		$error = '<br /><br /><strong>Error: </strong>'.$error;

	echo '
<style type="text/css">
h1 { 
	margin:0px;
	font-size:20px;
}

</style>

<title>WallScript - DGT</title>
<body bgcolor="#F4D7B6">
<center><div style="font-family: Helvetica, Arial, sans-serif; font-size:14px; padding:12px; height:50%; color: grey; width:35%; text-align:left; background-color: #FCF5ED; border:1px #DEAD82 solid;">
<h1>Another fine DGT release.</h1><br />
<form action="install.php?act=submit" method="post">
<br /><br />
<input type="submit" style="height:28px; font-size:16px; border:1px #DEAD82 solid;" value="Submit" /></form>'.$error.'
</div>
<a href="install.php?act=clear_method" style="font-family: Helvetica, Arial, sans-serif; font-size:14px; color:#194891;">New Connection Method</a>
</center>
</body>
';

	exit;

}

$HideFunc = true;
$dntConnect = true;

if( ! defined('FILE_APPEND')) define('FILE_APPEND', 1);
if (! isset($_GET['step']) || $_GET['step'] == null)
{
	$step = 0;
	$display = Welcome();
} else 
{
	$step = addslashes($_GET['step']);
	switch ($step) {
		case 1:
			$display=Step1();
			break;
		case 2:
			$display=Step2();
			break;
		case 3:
			$display=Step3();
			break;
		case -1:
			$display = MySQL_Settings();
			break;
		case 'confirm_mysql':
			$display = confirm_mysql();
			break;
		default:
			$display = Welcome();
			break;
	}
}

function confirm_mysql() {
	global $_POST;
	global $helpDesc;
	global $helpTitle;
	global $step;
	global $MySQL_Force;

	$step=1;

	$helpTitle = "MySQL Error";
	$helpDesc = "There was an error setting up the MySQL details.";

	error_reporting(0);

	$MySQL['host'] = addslashes($_POST['host']);
	$MySQL['user'] = addslashes($_POST['username']);
	$MySQL['pass'] = addslashes($_POST['password']);
	$MySQL['database'] = addslashes($_POST['database']);
	$MySQL['prefix'] = addslashes($_POST['prefix']);

	if ($MySQL['host']== null || $MySQL['user']== null || $MySQL['database']== null)
		return "Please submit the form correctly.";


	$cn = mysql_connect($MySQL['host'], $MySQL['user'], $MySQL['pass']);

	if (!$cn)
		return 'There was an error connecting to the database.<br /><strong>Error:</strong> ' . mysql_error();

	$db = mysql_select_db($MySQL['database']);

	if (!$db)
		return 'There was an error selecting the database. <br /><strong>Error:</strong> ' . mysql_error();

	$MySQL_Force = str_replace('{host}', $MySQL['host'], $MySQL_Force);
	$MySQL_Force = str_replace('{username}', $MySQL['user'], $MySQL_Force);
	$MySQL_Force = str_replace('{password}', $MySQL['pass'], $MySQL_Force);
	$MySQL_Force = str_replace('{database}', $MySQL['database'], $MySQL_Force);

	$file="../includes/mysql.php";

	$fp = fopen($file,"w+");
	fwrite($fp, NULL);
	fwrite($fp, $MySQL_Force);
	fclose($fp);

	header("Location: install.php?step=1");

}



function MySQL_Settings() {
	global $step;
	global $helpDesc;
	global $helpTitle;

	$WriteTrue = '<span style="color: #B8C049; font-weight: bold;">writeable</span>';
	$WriteFalse = '<span style="color: red; font-weight: bold;">not writeable</span>';

	$Wallpapers = is_writeable("../wallpapers/") ? $WriteTrue : $WriteFalse;
	$Tmp = is_writeable("../tmp/") ? $WriteTrue : $WriteFalse;
	$Thumbnails = is_writeable("../thumbnails/") ? $WriteTrue : $WriteFalse;
	$Templates = is_writeable("../templates/") ? $WriteTrue : $WriteFalse;
	$Cache = is_writeable("../etc/cache/") ? $WriteTrue : $WriteFalse;
	$Bulk = is_writeable("../bulk/") ? $WriteTrue : $WriteFalse;
	$AdminTmp = is_writeable("../admin/tmp/") ? $WriteTrue : $WriteFalse;
	$MySQL = is_writeable("../includes/mysql.php") ? $WriteTrue : $WriteFalse;

	if(! writeable($MySQL) && ! writeable($Wallpapers) && ! writeable($Tmp) && ! writeable($Thumbnails) && ! writeable($Templates) && ! writeable($Cache) && ! writeable($Bulk) && ! writeable($AdminTmp))
		$Write = true;
	else $Write = false;

	$Permissions = <<<EOF
<br /><strong>Permission Settings</strong><br />
	First you must make sure the following directories are all writeable (chmod to 0777).
	<table>
		<tr>
			<td width=200>/wallpapers/</td>
			<td>$Wallpapers</td>
		</tr>
		<tr>
			<td width=200>/tmp/</td>
			<td>$Tmp</td>
		</tr>
		<tr>
			<td width=200>/thumbnails/</td>
			<td>$Thumbnails</td>
		</tr>
		<tr>
			<td width=200>/templates/</td>
			<td>$Templates</td>
		</tr>
		<tr>
			<td width=200>/etc/cache/</td>
			<td>$Cache</td>
		</tr>
		<tr>
			<td width=200>/bulk/</td>
			<td>$Bulk</td>
		</tr>
		<tr>
			<td width=200>/admin/tmp/</td>
			<td>$AdminTmp</td>
		</tr>
		<tr>
			<td width=200>/includes/mysql.php</td>
			<td>$MySQL</td>
		</tr>

	</table><br />
EOF;

	$step = 1;

	$helpDesc = "Please fill out your MySQL database details to the left.<br /> ";
	$helpTitle = "MySQL Details";

	$r = '<span style="font-size:110%;">Please fill out the form below to submit your MySQL settings.</span><br />
	'. $Permissions;

	if($Write == true)
	{
		$r = '
	<form action="install.php?step=confirm_mysql" method="post">
	<b>MySQL Settings:</b><table><tr><td width="200">Host:</td><td><input type="text" name="host" value="localhost"></td></tr><tr><td width="200">MySQL Username:</td><td><input type="text" name="username"></td></tr><tr><td width="200">MySQL Password:</td><td><input type="text" name="password"></td></tr><tr><td width="200">MySQL Database:</td><td><input type="text" name="database"></td></tr></table><br /><input type="submit" value="Submit Details"></form>';
	
	}

	return $r;
}

function writeable($Var)
{
	return strpos($Var, 'red');
}

function Step3() {
	global $_POST;
	global $Base_SQL;
	global $Info;
	global $method;
	global $helpTitle;
	global $helpDesc;

	include_once("../includes/mysql.php");
	
	$MySQL_Host = $MySQL['host'];
	$MySQL_Username = $MySQL['username'];
	$MySQL_Password = $MySQL['password'];
	$MySQL_Database = $MySQL['database'];

	
	$helpTitle = "Installation Complete";
	$helpDesc = "There was an error updating your settings. Please try again";

	$db=mysql_connect ($MySQL_Host, $MySQL_Username, $MySQL_Password);
	$sd=mysql_select_db ($MySQL_Database);

	if ($_POST['admin_username']== null||$_POST['admin_password']== null)
		return '<strong>Error:</strong> You must enter a username and password.<br /><br /><center><a href="install.php?step=2" style="font-size:20px;">Back</a></center>';

	$Username=addslashes($_POST['admin_username']);
	$Password=md5(addslashes($_POST['admin_password']));
	
	$Info['name']=addslashes($_POST['name']);
	$Info['slogan']=addslashes($_POST['slogan']);
	$Info['url']= addslashes($_POST['url']);
	$Info['keywords']=addslashes($_POST['keywords']);
	$Info['description']=addslashes($_POST['description']);

	if(substr($Info['url'], -1) != "/")
		$Info['url'] .= "/";
	$Info['url'] = str_ireplace('index.php', null, $Info['url']);
	
	$Query="INSERT INTO users (`username`, `password`, `admin`, `name`, `email`, `gender`, `join`, `avatar`) VALUES ('$Username', '$Password', '1', 'Admin', 'email@domain.com', 1, " . time() . ", 'images/avatars/thinking.gif')";
	mysql_query($Query) or die(mysql_error());
	
	@mysql_query("UPDATE `settings` SET `value`='".$Info['name']."' WHERE identifier = 'Site_Title'") or die(mysql_error());
	@mysql_query("UPDATE `settings` SET `value`='".$Info['slogan']."' WHERE identifier = 'Website_Slogan'") or die(mysql_error());
	@mysql_query("UPDATE `settings` SET `value`='".$Info['url']."' WHERE identifier = 'Website_URL'") or die(mysql_error());
	@mysql_query("UPDATE `settings` SET `value`='".$Info['keywords']."' WHERE identifier = 'Meta_Keywords'") or die(mysql_error());
	@mysql_query("UPDATE `settings` SET `value`='".$Info['description']."' WHERE identifier = 'Meta_Description'") or die(mysql_error());

	$helpDesc = "Your website has successfully been installed. To complete the installation, please follow the instructions on your left.";
	
	return '<span style="font-size:110%;">You have finished installing our product. We suggest you first log in to the <a href="../admin/" style="color:navy;">Admin Panel</a> to start properly setting up your new website.<br /><br /><b>Warning: Please delete the installation directy right now, as leaving it could pose a huge security risk.</span>';
}

function Step2() {
	global $helpTitle;
	global $helpDesc;

	$helpTitle = "Update Settings";
	$helpDesc = "The form to the left will allow you to create an Admin account, and to also update important settings for your site";

	return '
	<span style="font-size:110%;">Please fill out the form below to create an Admin account and update your website settings.</span><br />
	<form action="install.php?step=3" method="post">
	<b>Administrator Account:</b><table><tr><td width="200">Username:</td><td><input type="text" name="admin_username"></td></tr><tr><td width="200">Password:</td><td><input type="text" name="admin_password"></td></tr></table><br /><strong>Website Details</strong><table><tr><td width="200">Website name</td><td><input type="text" name="name"></td></tr><tr><td width="200">Website slogan:</td><td><input type="text" name="slogan"></td></tr><tr><td width="200">Website URL:</td><td><input type="text" name="url"></td></tr><tr><td width="200">Homepage keywords:</td><td><input type="text" name="keywords"></td></tr><tr><td width="200">Meta description</td><td><input type="text" name="description"></td></tr></table><br /><br /><input type="submit" value="Create Account"></form>
	';
}


function is_md5($var) 
{
	return preg_match('/^[A-Fa-f0-9]{20}$/', $var);
}

function Step1() {
	global $Base_SQL;
	global $MySQL_Host;
	global $MySQL_Username;
	global $MySQL_Password;
	global $MySQL_Database;
	global $helpDesc;
	global $helpTitle;

	$helpTitle = "Install Mysql Tables";

	include_once("../includes/mysql.php");
	
	$MySQL_Host = $MySQL['host'];
	$MySQL_Username = $MySQL['username'];
	$MySQL_Password = $MySQL['password'];
	$MySQL_Database = $MySQL['database'];


	error_reporting(0);

	$db=mysql_connect ($MySQL_Host, $MySQL_Username, $MySQL_Password);
	$sd=mysql_select_db ($MySQL_Database);

	$helpDesc = "There was an error creating the tables. Please confirm your details prior to continuing.";

	if (!$db) {
		return '<h4><strong>Error</strong>: Unable to connect to the database. Please make sure you entered the correct MySQL details in includes/config.php</h4>';
	}

	if (!$sd) {
		return '<h4><strong>Error</strong>: Unable to select to the database. Please make sure you entered the correct MySQL details in includes/config.php</h4>';
	}

	foreach($Base_SQL as $Query)
	{
		mysql_query($Query, $db) or die(mysql_error().'<br />'.$Query);
	}

	$helpDesc = "Congratulations, you have now installed the MySQL tables successfully. To move on to the next stage, please click on the 'Continue' link located on the left of this message.";

	return '<span style="font-size:110%;">Set up database complete.<br /><br /><center><a href="install.php?step=2" style="font-size:20px;">Continue</a></center></span>';
}

function Welcome() {
	global $helpTitle;
	global $helpDesc;

	

	$helpTitle = "Begin Installation";
	$helpDesc = "To begin the installation, please click the link on the left. The entire process should take a maximum of two minutes.";

	return '
	<span style="font-size:110%;">Welcome to the installation of your new website powered by ajberri\'s WallScript. </span>
	
	<br /><br />
	If this is your first time installing the script, we strongly suggest you read the installation files that came with the download. For further assistance, feel free to make a thread on the WallScript Support Forums.
	<br /><br />
	The installation process will require you to entire specific details for your site, such as your publisher settings, website name and basic website details. If you are undecided about these settings, you have the ability to edit these at a later date. 
	<br /><br />
<center><a href="install.php?step=-1" style="font-size:20px;">Start Installation</a></center>
	';
}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<meta http-equiv="content-type" content="text/html;charset=iso-8859-2" />
	<meta name="author" content="Luka Cvrk" />
	<link rel="stylesheet" href="style.css" type="text/css" />
	<title>WallScript Installation</title>
</head>
<body>
	<div id="content">
		<div id="header">
			<p id="top_info">WallScript - One stop source for premium wallpaper resources<br />For support, please visit our Support Forums</p>
			
			<div id="logo">
				<h1><a href="install.php" title="WallScript Installation">Wall <span class="title">Script</span></a></h1>
				<p>Installation Step <?php echo $step; ?></p>
			</div>
		</div>
					
		<div id="tabs">
			&nbsp;
		</div>
					
<br />
		
		<div class="left" style="margin-top:-50px;">
			<div class="left_articles">
				<h2 style="margin:0px;">Installation Step <?php echo $step; ?></h2>
				<p class="description">For information on how to install please visit the WallScript Support Forums</p>
				<p><?php echo $display; ?></p>
				<br />
			</div>
					
			<div class="thirds">
				<div class="smallboxtop"></div>
				<div class="smallbox">
					<h3 style="margin:0px;">Step 1</h3>
					<p>Confirm MySQL details.</p>
				</div>
			</div>
		
			<div class="thirds">
				<div class="smallboxtop"></div>
				<div class="smallbox">
					<h3 style="margin:0px;">Step 2</h3>
					<p>Install MySQL tables.</p>
				</div>
			</div>
		
			<div class="thirds">
				<div class="smallboxtop"></div>
				<div class="smallbox">
					<h3 style="margin:0px;">Step 3</h3>
					<p>Configure basic site settings.</p>
				</div>
			</div>
		</div>	
		
		<div id="right">
			<div class="boxtop"></div>
			<div class="box">
				<p><img src="images/image.gif" alt="Image" title="Image" class="image" /><b><?php echo $helpTitle; ?></b><br /><?php echo $helpDesc; ?><br /></p>
				
			</div>

		</div>	
		<div class="footer">
			<p>
			WallScript is &copy; Copyright 2010 ajberri. All Rights Reserved.</p>
		</div>
	</div>
</body>
</html>