<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: n/a
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/


$Base_SQL = array();

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `admin_bulk` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `folders` text NOT NULL,
  `complete` int(11) NOT NULL,
  `start` int(11) NOT NULL,
  `end` int(11) NOT NULL,
  `last_update` int(11) NOT NULL,
  `admin` int(11) NOT NULL,
  `cat` int(11) NOT NULL,
  `names` int(11) NOT NULL,
  `resize` int(11) NOT NULL,
  `special` int(11) NOT NULL,
  `numbers` int(11) NOT NULL,
  `ordered` int(11) NOT NULL,
  `delete` int(11) NOT NULL,
  `capitalize` int(11) NOT NULL,
  `rand` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;';

$Base_SQL[] = '
CREATE TABLE IF NOT EXISTS `announcements` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `val` text NOT NULL,
  `start` int(11) NOT NULL,
  `end` int(11) NOT NULL,
  `started_by` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `bans` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `aid` int(11) NOT NULL,
  `time` int(11) NOT NULL,
  `reason` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `desc` varchar(255) NOT NULL,
  `parent` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `wid` int(11) NOT NULL,
  `uid` int(11) NOT NULL,
  `rating` int(11) NOT NULL,
  `time` int(11) NOT NULL,
  `user` varchar(255) NOT NULL,
  `comment` varchar(255) NOT NULL,
  `ip` varchar(255) NOT NULL,
  `parent_id` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `comment_ratings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL,
  `ip` varchar(255) NOT NULL,
  `type` varchar(1) NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `comment_reports` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL,
  `status` int(11) NOT NULL,
  `reason` varchar(255) NOT NULL,
  `ip` varchar(255) NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `filter_sessions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sort` varchar(50) NOT NULL,
  `order` varchar(10) NOT NULL,
  `time` varchar(10) NOT NULL,
  `cat` int(11) NOT NULL,
  `unique` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `login_attempts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `username` varchar(255) NOT NULL,
  `password` varchar(255) NOT NULL,
  `ip` varchar(255) NOT NULL,
  `time` int(11) NOT NULL,
  `admin` int(11) NOT NULL,
  `success` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `messages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `to` int(11) NOT NULL,
  `from` int(11) NOT NULL,
  `title` varchar(255) NOT NULL,
  `message` text NOT NULL,
  `time` int(11) NOT NULL,
  `read` int(11) NOT NULL DEFAULT \'0\',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `partners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  `name` varchar(255) NOT NULL,
  `anchor` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `pass_request` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` int(11) NOT NULL,
  `expire` int(11) NOT NULL,
  `uid` int(11) NOT NULL,
  `ip` varchar(255) NOT NULL,
  `password` varchar(255) NOT NULL,
  `active` int(11) NOT NULL,
  `rand` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `plugins` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `identifier` varchar(255) NOT NULL,
  `class` varchar(255) NOT NULL,
  `filepath` varchar(255) NOT NULL,
  `installed` int(11) NOT NULL DEFAULT \'0\',
  `version` varchar(255) NOT NULL,
  `image` varchar(255) NOT NULL,
  `description` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `plugin_code` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `script` text NOT NULL,
  `query` text NOT NULL,
  `code` text NOT NULL,
  `called` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `plugin_settings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `identifier` varchar(255) NOT NULL,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `settings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `identifier` varchar(255) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `templates` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `path` varchar(255) NOT NULL,
  `selected` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `users` (
  `userid` int(11) NOT NULL AUTO_INCREMENT,
  `username` varchar(255) NOT NULL,
  `password` varchar(32) NOT NULL,
  `email` varchar(255) NOT NULL,
  `country` varchar(255) NOT NULL,
  `name` varchar(255) NOT NULL,
  `gender` int(11) NOT NULL,
  `secret_question` varchar(255) NOT NULL,
  `secret_answer` varchar(255) NOT NULL,
  `avatar` varchar(255) NOT NULL DEFAULT \'/images/no-avatar.jpg\',
  `usergroup` int(11) NOT NULL DEFAULT \'1\',
  `join` int(11) NOT NULL,
  `public_email` int(11) NOT NULL,
  `msn` varchar(255) NOT NULL,
  `aim` varchar(255) NOT NULL,
  `skype` varchar(255) NOT NULL,
  `about` text NOT NULL,
  `admin` int(11) NOT NULL,
  PRIMARY KEY (`userid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `user_comment` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `rid` int(11) NOT NULL,
  `uid` int(11) NOT NULL,
  `message` varchar(255) NOT NULL,
  `date` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `votes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ip` varchar(255) NOT NULL,
  `wid` int(11) NOT NULL,
  `rating` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `wallpapers` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cat` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `desc` varchar(255) NOT NULL,
  `views` int(11) NOT NULL,
  `thumbSmall` varchar(255) NOT NULL,
  `thumbLarge` varchar(255) NOT NULL,
  `votes` int(11) NOT NULL,
  `votecount` int(11) NOT NULL,
  `tags` varchar(255) NOT NULL,
  `time` int(11) NOT NULL,
  `author` varchar(255) NOT NULL,
  `downloads` int(11) NOT NULL,
  `comments` int(11) NOT NULL,
  `status` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = 'CREATE TABLE IF NOT EXISTS `wallpaper_uploads` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `wid` int(11) NOT NULL,
  `width` int(11) NOT NULL,
  `height` int(11) NOT NULL,
  `url` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
';

$Base_SQL[] = "INSERT INTO `categories` VALUES('1', 'Nature', 'Nature Wallpapers.', '0');";

$Base_SQL[] = <<<EOF
INSERT INTO `settings` (`identifier`, `value`) VALUES
('Template', 'templates/BlueWonder/'),
('Site_Title', ''),
('home_title', 'Welcome!'),
('home_desc', 'Your homepage description goes here.'),
('dimensions', '1024x768|1152x864|1280x1024|1600x1200|1920x1440|2560x1920|1280x800|1440x900|1680x1050|1920x1200|2560x1600'),
('curse_words', 'shit,cunt,bitch,damn,nigga,nigger'),
('guest_submit', '1'),
('WallpapersPerPage', '3'),
('Meta_Description', ''),
('Meta_Keywords', ''),
('Website_URL', ''),
('Website_Slogan', ''),
('auto_resize', '1'),
('comments_on_wallpaper', '1'),
('wallpaper_comments_per_page', '5'),
('show_similar_wallpapers', '1'),
('show_top_wallpapers', '1'),
('show_latest_wallpapers', '1'),
('alphabetize_cats', '1'),
('cats_pag', '1'),
('cats_per_page', '18'),
('cat_stats', '1'),
('users_active', '1'),
('users_login_by', '1'),
('force_captcha', '0'),
('auto_approve_wallpapers', '1'),
('rating_sunk', '-3'),
('publickey', ''),
('privatekey', ''),
('homepage_title', '(website) - (slogan)'),
('category_page_title', '(category) Wallpapers - (website)'),
('wallpaper_page_title', '(wallpaper) Wallpaper - (website)'),
('replace_non_english', '0'),
('remove_stopwords', '1'),
('define_stopwords', 'a\r\nan\r\nand\r\nare\r\nas\r\nat\r\nbe\r\nby\r\nfor\r\nfrom\r\nin\r\nis\r\nit\r\nof\r\non\r\nor\r\nthat\r\nthe\r\nthis\r\nto\r\nwas\r\nwhich\r\nwith'),
('define_seperator', '1'),
('url_length', '0'),
('google_analytics', '1'),
('google_analytics_code', 'UA-9127649-1'),
('file_not_found', '2'),
('file_not_found_custom', '404.php'),
('include_domain_link', '1'),
('adslot_1', '<a href="#"><img src="&&path&&images/ad.jpg" alt="" /></a>'),
('adslot_2', ''),
('adslot_3', ''),
('adslot_4', ''),
('adslot_5', ''),
('analytics_code', ''),
('watermark_font', ' arial.ttf'),
('watermark_enabled', '0'),
('watermark_text', 'Example Watermark'),
('watermark_font_size', '30'),
('watermark_position', '1'),
('watermark_last_edit', '1267502405'),
('watermark_color', 'FFFFFF'),
('email_message', 'Hello,\r\nYou are receiving this email because somebody has recommended the wallpaper ''{Wallpaper_Name}'' over at {Site_Title}.\r\nTo view the wallpaper, click <a href="{Link}">here</a>, or copy and paste the link below.\r\n{Link}\r\nSincerely,\r\n{Site_Title}'),
('email_title', 'You have been sent a wallpaper link!');
EOF;

$Base_SQL[] = "INSERT INTO `wallpapers` (`cat`, `name`, `desc`, `views`, `thumbSmall`, `thumbLarge`, `votes`, `votecount`, `tags`, `time`, `author`, `downloads`, `comments`, `status`) VALUES
(1, 'Nature trail', 'Nature trail wallpaper.', 1, 'thumbnails/nature_trail_85696.jpeg', 'thumbnails/large_nature_trail_68589.jpeg', 0, 0, 'nature, trail', 1268106348, 'admin', 0, 0, 1);
";

$Base_SQL[] = "INSERT INTO `wallpaper_uploads` (`wid`, `width`, `height`, `url`) VALUES
(1, 1600, 1200, 'wallpapers/nature_trail_1600x1200_1.jpeg'),
(1, 1024, 768, 'wallpapers/nature_trail_1024x768_1.jpeg'),
(1, 1152, 864, 'wallpapers/nature_trail_1152x864_1.jpeg');
";

$Base_SQL[] = "INSERT INTO `templates` (`title`, `path`, `selected`) VALUES
('Default Template', 'templates/Default/', 0);";

$Base_SQL[] = "ALTER TABLE `plugin_code` ADD `template` VARCHAR( 255 ) NOT NULL";
$Base_SQL[] = "ALTER TABLE `plugin_code` ADD `product` VARCHAR( 255 ) NOT NULL AFTER `id`";
$Base_SQL[] = "ALTER TABLE `plugin_code` ADD `TemplateDir` VARCHAR( 255 ) NOT NULL";
$Base_SQL[] = "INSERT INTO `settings` (`identifier` , `value`) VALUES ( 'custom_rewrite', '' )";
$Base_SQL[] = "ALTER TABLE `partners` ADD `description` VARCHAR( 255 ) NOT NULL";
$Base_SQL[] = "INSERT INTO `templates` (`title`, `path`, `selected`) VALUES ('BlueWonder', 'templates/BlueWonder/', 1);";
$Base_SQL[] = "ALTER TABLE `plugin_settings` ADD `desc` VARCHAR( 255 ) NOT NULL , ADD `type` VARCHAR( 255 ) NOT NULL , ADD `options` TEXT NOT NULL";

// Version 1.1.2 changes
$Base_SQL[] = "INSERT INTO `settings` (`id`, `identifier`, `value`) VALUES (NULL, 'debug_mode', '0');";
$Base_SQL[] = "ALTER TABLE `admin_bulk` ADD `extra` TEXT NOT NULL";
$Base_SQL[] = "INSERT INTO `settings` (`id`, `identifier`, `value`) VALUES (NULL, 'wsversion', '1.1.2');";

?>