<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: Index
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

class Index
{
    var $class;
    var $return = array();
    var $Output;
    
    function run()
    {
        $this->return['path'] = '';
        
        // Lets get some of the html going.
        $this->Output .= $this->class->template->LoadTemplate("box_left.cphp", array("path" => $this->return['path']));
        
        // Get the top downloaded wallpapers
        $Query = "SELECT * FROM `wallpapers` WHERE `status` = 1 ORDER BY `views` DESC LIMIT 4";
        $Res = $this->class->mysql->Query($Query);
        $Wallpapers = $this->class->mysql->FetchResults($Res);

		$Query = "SELECT `name`, `id` FROM `categories`";
		$Result = $this->class->mysql->Query($Query);
		$Cats = $this->class->mysql->FetchResults($Result);
		
		foreach($Cats as $Cat)
			$CatsArr[$Cat['id']] = $Cat['name'];
        
        $this->Output .= $this->class->template->LoadTemplate("home/top_wall.cphp", $this->return);
        
        foreach ($Wallpapers as $val)
        {
			$CatUrl = utf8_encode(strtolower(str_replace(array(" "), $this->class->Settings['identifier'], $CatsArr[$val['cat']])));

            $rep = array(
                "name"      => $val['name'],
                "image"     => $val['thumbSmall'],
                "title"     => $CatUrl . "/" . utf8_encode(str_replace(" ", $this->class->Settings['identifier'], strtolower($val['name']))),
                "id"        => $val['id'],
                
            );
            $this->Output .= $this->class->template->LoadTemplate("home/wallpaper.cphp", $rep);
        }
        
        $this->Output .= $this->class->template->LoadTemplate("home/bot_wall.cphp", array());
        $this->Output .= $this->class->template->LoadTemplate("home/bot_boxl.cphp", array());
        
        // Welcome box
        $this->Output .= $this->class->template->LoadTemplate("welcome.cphp", array(
				"path" => $this->return['path'], 
				"title" => $this->class->Settings['home_title'],
				"desc" => $this->class->Settings['home_desc']
        ));
        
        // Categories
        $this->Output .= $this->class->template->LoadTemplate("global/boxthin_left.cphp", $this->return);
        $this->Output .= $this->class->CompileCategories();
        $this->Output .= $this->class->CompilePartners();;
        $this->Output .= $this->class->template->LoadTemplate("global/cats_end.cphp", $this->return);
        
        // Newest wallpapers
        $rep = array("newest_title1" => $this->class->lang->Phrase['newest_title'], "path" => $this->return['path']);
        $this->Output .= $this->class->template->LoadTemplate("home/newest_s.cphp", $rep);
        
        $Query = "SELECT * FROM `wallpapers` WHERE `status` = 1 ORDER BY `id` DESC LIMIT 4";
        $Res = $this->class->mysql->Query($Query);
        $Wallpapers = $this->class->mysql->FetchResults($Res);
            
        foreach ($Wallpapers as $val)
        {
			$CatUrl = utf8_encode(strtolower(str_replace(array(" "), $this->class->Settings['identifier'], $CatsArr[$val['cat']])));

            $rep = array(
                "name"      => $val['name'],
                "image"     => $val['thumbSmall'],
                "title"     => $CatUrl . "/" . utf8_encode(str_replace(" ", $this->class->Settings['identifier'], strtolower($val['name']))),
                "id"        => $val['id'],
                
            );
            $this->Output .= $this->class->template->LoadTemplate("home/wallpaper.cphp", $rep);
        }
        
        $this->Output .= $this->class->template->LoadTemplate("home/newest_e.cphp", $this->return);
        
        // Top rated wallpapers
        $rep = array("newest_title1" => $this->class->lang->Phrase['top_rated'], "path" => $this->return['path']);
        $this->Output .= $this->class->template->LoadTemplate("home/newest_s.cphp", $rep);
        
        $Query = "SELECT * FROM `wallpapers` WHERE `status` = 1 ORDER BY `votecount`/`votes` DESC LIMIT 4";
        $Res = $this->class->mysql->Query($Query);
        $Wallpapers = $this->class->mysql->FetchResults($Res);
            
        foreach ($Wallpapers as $val)
        {
			$CatUrl = utf8_encode(strtolower(str_replace(array(" "), $this->class->Settings['identifier'], $CatsArr[$val['cat']])));

            $rep = array(
                "name"      => $val['name'],
                "image"     => $val['thumbSmall'],
                "title"     => $CatUrl  . "/" . utf8_encode(str_replace(" ", $this->class->Settings['identifier'], strtolower($val['name']))),
                "id"        => $val['id'],
                
            );
            $this->Output .= $this->class->template->LoadTemplate("home/wallpaper.cphp", $rep);
        }
        
        $this->Output .= $this->class->template->LoadTemplate("home/newest_e.cphp", $this->return);
        
		// Title
		$this->class->page['title'] = $this->class->Settings['homepage_title'];
		$this->class->page['title'] = str_replace('(website)', $this->class->Settings['Site_Title'], $this->class->page['title']);
		$this->class->page['title'] = str_replace('(slogan)', $this->class->Settings['Website_Slogan'], $this->class->page['title']);

        return $this->Output;
    
    }

}

?>