<?php

// This is the home file we are going to use for the DarkBox template.

class Index
{
    var $class;
    var $return = array();
    var $Output;
    
    function run()
    {
        $this->return['path'] = '';

		$Query = "SELECT `name`, `id` FROM `categories`";
		$Result = $this->class->mysql->Query($Query);
		$Cats = $this->class->mysql->FetchResults($Result);
		
		// Grab the cats
		foreach($Cats as $Cat)
			$CatsArr[$Cat['id']] = $Cat['name'];
        
        // Select random wallpapers
        $Query = "SELECT * FROM `wallpapers` WHERE `status` = 1 ORDER BY RAND() LIMIT 9";
        $Res = $this->class->mysql->Query($Query);
        $Wallpapers = $this->class->mysql->FetchResults($Res);

		$this->Output .= $this->class->template->LoadTemplate("home/rand_block_start.cphp");
		$this->Output .= $this->class->template->LoadTemplate("home/start_wrap.cphp");
        
        foreach ($Wallpapers as $id => $val)
        {
			if( $val['votes'] > 0 ) {
				$Rating = floor( (int) $val['votecount'] / (int) $val['votes'] );
			} else $Rating = 0;

			$Star = null;
			for( $x = 1; $x <= 5; $x++ ) {
				$Num = ( $Rating < $x ) ? 2 : 1;
				$Star .= $this->class->template->LoadTemplate("home/homestar.cphp", array("img" => $Num));
			}			

			$CatUrl = utf8_encode(strtolower(str_replace(array(" "), $this->class->Settings['identifier'], $CatsArr[$val['cat']])));
  		
			$rep = array(
                "name"      => $val['name'],
                "image"     => $val['thumbSmall'],
                "title"     => $CatUrl . "/" . utf8_encode(str_replace(" ", $this->class->Settings['identifier'], strtolower($val['name']))),
                "id"        => $val['id'],
				"star"		=> $Star,
				"rating"	=> $Rating,
                
            );
            $this->Output .= $this->class->template->LoadTemplate("home/wallpaper.cphp", $rep);
			if($id%3==2) $this->Output .= "</tr>\n";
        }
		$this->Output .= "<div style='clear:both;'></div>";

		$this->Output .= $this->class->template->LoadTemplate("home/end_wrap.cphp");
		$this->Output .= $this->class->template->LoadTemplate("home/end_block.cphp");
        
		// Title
		$this->class->page['title'] = $this->class->Settings['homepage_title'];
		$this->class->page['title'] = str_replace('(website)', $this->class->Settings['Site_Title'], $this->class->page['title']);
		$this->class->page['title'] = str_replace('(slogan)', $this->class->Settings['Website_Slogan'], $this->class->page['title']);

        return $this->Output;
    
    }

}

?>