<?php

class Debug {

	// Class property.
	public $class;

	// Data array
	private $Data = array();

	public function __construct( $Parent ) {
		$this->class = $Parent;
	}

	// Add data
	public function addData( $Args ) {
		$this->Data[] = $Args;
	}

	// Retrieve data
	public function retrieveData() {
		return $this->Data;
	}

	// Output the data
	public function Out() {

		// Is debug mode turned on?
		if( (int) $this->class->Settings['debug_mode'] === 1 ) {

			// Is there any data to output?
			if( sizeOf( $this->Data ) > 0 ) {
				
				// Loop through the array and output results
				require_once( WS_PATH . "/templates/global/debug/page.phtml" );

			}

		}

	}

}


?>