<?php

/*
+--------------------------------------------------------------------------
|   WallScript
|   ========================================
|   by Alex Roxon
|   (c) 2010 ajberri
|   http://www.ajberri.com
|   ========================================
|   Web: http://www.ajberri.com
|   Email: alex@ajberri.com
+---------------------------------------------------------------------------
|   THIS SCRIPT MAY HAVE LICENSING RESTRICTIONS
|   http://www.ajberri.com/license
+---------------------------------------------------------------------------
|
|   > Class: Styles
|   > Script written by Alex Roxon
|   > Date started: 2010
|	> Date updated: Mar 09 2010
|
+--------------------------------------------------------------------------
*/

class Styles
{

	var $Settings;
	var $class;

	function auto_run()
	{
		Functions::$Var['Selected'] = 5;

		switch($this->class->main->Data("do"))
		{
			case 'editstyle':
				return $this->edit();
				break;
			case 'edit':
				return $this->edittemplate();
				break;
			case 'set_default_style':
				return $this->set_default_style();
				break;
			case 'deletestyle':
				return $this->deletestyle();
				break;
			case 'submit_edit':
				return $this->submit_edit();
				break;
			case 'import':
				return $this->import();	
				break;
			case 'submit_import':
				return $this->submit_import();
				break;

			default:
				return $this->showcase_styles();
				break;
		}
	}

	function submit_import()
	{
		Functions::DemoCheck();

		if ($_FILES['file']['name'] == NULL) 
			Functions::AdminError('You must upload a file in order to submit a new theme.');;

		$name = "tmp/import-" . rand(1,1000000) . ".php";

		$upload = move_uploaded_file($_FILES['file']['tmp_name'], $name);

		if (!$upload)
			Functions::AdminError('Could not upload text file.');

		include_once($name);

		if ($Template['Title'] == NULL || $Template['Path'] == NULL)
			Functions::AdminError('No template title or path variable found.');

		$Q = "SELECT COUNT(*) FROM `templates` WHERE `title` = '" . $Template['Title'] . "'";
		$R = $this->class->main->mysql->Query($Q);
		$T = $this->class->main->mysql->FetchResults($R);
		
		if( (int) $T[0]['COUNT(*)'] > 0)
			Functions::AdminError("Template already exists.");

		$templateQuery = "INSERT INTO `".PREFIX."templates` (`title`,`path`) VALUES('".$Template['Title']."','".$Template['Path']."')";
		$templateResult = $this->class->main->mysql->Query($templateQuery);
		$Id = mysql_insert_id();
		
		if(isset($Query) && isset($Query[0]) && is_array($Query))
			foreach($Query as $Q)
				$this->class->main->mysql->Query($Q);

		Functions::Redirect( 'Template has been uploaded.', 'index.php?act=styles' );


	}

	function import()
	{
		$ret = Functions::LoadTemplate("import_style");
		$Section = Functions::BuildSection("Import Style", $ret);

		return $Section;
	}

	function submit_edit()
	{
		Functions::DemoCheck();

		$Id = $this->class->main->Data("id");

		if($Id == null || ! is_numeric($Id))
			Functions::AdminError("Invalid id entered.");

		$Query = "SELECT * FROM `".PREFIX."templates` WHERE `id`='$Id'";
		$Result = $this->class->main->mysql->Query($Query);
		$Template = $this->class->main->mysql->FetchResults($Result);

		if (count($Template) == 0 || ! is_array($Template))
			Functions::AdminError("Style does not exist.");

		$Template = $Template[0];
		$Templ = $this->class->main->Data("template");
		
		if($Templ == null)
			Functions::AdminError("Must enter a template to edit.");

		if(! file_exists($Templ))
			Functions::AdminError("Template does not exist.");

		if(! is_writeable($Templ))
			Functions::AdminError("Template not writeable.");

		file_put_contents($Templ, $_POST['templatevalue']);

		Functions::Redirect( 'Template file edited', 'index.php?act=styles&do=editstyle&id=' . $Id );


	}

	function edittemplate()
	{
		$Id = $this->class->main->Data("id");

		if($Id == null || ! is_numeric($Id))
			Functions::AdminError("Invalid id entered.");


		$Query = "SELECT * FROM `".PREFIX."templates` WHERE `id`='$Id'";
		$Result = $this->class->main->mysql->Query($Query);
		$Template = $this->class->main->mysql->FetchResults($Result);

		if (count($Template) == 0 || ! is_array($Template))
			Functions::AdminError("Style does not exist.");

		$Template = $Template[0];
		$Templ = $this->class->main->Data("template");
		
		if($Templ == null)
			Functions::AdminError("Must enter a template to edit.");

		if(! file_exists($Templ))
			Functions::AdminError("Template does not exist.");

		$File = file_get_contents($Templ);

		if(Functions::str_contains($File, "<php>"))
		{
			$Edit = Functions::LoadTemplate("edit_template", array("template" => $File, "id" => $Id, "temp" => $Template['title'], "templatename" => $Templ), 0, false);
			$Edit = Functions::LoadTemplate("form", array("action" => '?act=styles&do=submit_edit&id=' . $Id, 'class' => 'search_form general_form', 'method' => 'post', 'content' => $Edit, 'id' => ''), 0, false);
			$Edit = Functions::BuildSection("Edit Template", $Edit, array(), false);

			die($Edit);
		}

		$Edit = Functions::LoadTemplate("edit_template", array("template" => $File, "id" => $Id, "temp" => $Template['title'], "templatename" => $Templ));
		$Edit = Functions::LoadTemplate("form", array("action" => '?act=styles&do=submit_edit&id=' . $Id, 'class' => 'search_form general_form', 'method' => 'post', 'content' => $Edit, 'id' => ''));
		$Edit = Functions::BuildSection("Edit Template", $Edit, array());

		return $Edit;

	}

	function edit()
	{
		$Id = $this->class->main->Data("id");

		if($Id == null || ! is_numeric($Id))
			Functions::AdminError("Invalid id entered.");

		$Query = "SELECT * FROM `".PREFIX."templates` WHERE `id`='$Id'";
		$Result = $this->class->main->mysql->Query($Query);
		$Num = $this->class->main->mysql->FetchResults($Result);

		if (count($Num) == 0 || ! is_array($Num))
			Functions::AdminError("Style does not exist.");

		$Num = $Num[0];

		Functions::$Var['n'] = 0;
		Functions::$Var['y'] = 0;
		$Files = Functions::TemplateFiles("../" . $Num['path'] . "templates/");

		$Options = null;
		$Templates = array();

		foreach($Files as $File)
		{
			$Pos = strrpos($File, "/") + 1;
			$Name = substr($File, $Pos, strlen($File));
			$Name = str_replace(array(".cphp", ".html"), null, $Name);
			$File = str_replace("//", "/", $File);

			$Templates[$Name] = $File;

		}

		ksort($Templates);

		foreach($Templates as $Name => $File)
			$Options .= "<option value='" . $File . "'>" . $Name . "</option>\n";

		$return = Functions::LoadTemplate("edit_templates", array("options" => $Options, "id" => $Num['id']));
		$return = Functions::BuildSection("Edit Style Templates", $return);

		return $return;

	}

	function deletestyle()
	{
		Functions::DemoCheck();

		$id = $this->class->main->Data('id');
		if ($id==NULL || ! is_numeric($id))
			Functions::AdminError("You must enter a valid id");

		$Query = "SELECT COUNT(*) FROM `".PREFIX."templates` WHERE `id`='$id' AND `selected`='0'";
		$Result = $this->class->main->mysql->Query($Query);
		$Num = $this->class->main->mysql->FetchResults($Result);
		$Num = (int) $Num[0]['COUNT(*)'];

		if ($Num == 0)
			Functions::AdminError("That style either does not exist or it is set to default. You can not delete the default style.");
	
		$this->class->main->mysql->Query("DELETE FROM `".PREFIX."templates` WHERE `id`='$id'");

		Functions::Redirect( 'Successfully deleted style.', 'index.php?act=styles' );

	}

	
	function set_default_style()
	{
		Functions::DemoCheck();

		$id = $this->class->main->Data('id');

		if ($id == NULL || ! is_numeric($id))
			Functions::AdminError("You must enter a valid id");

		$Query = "SELECT *, COUNT(*) FROM `".PREFIX."templates` WHERE `id`='$id' AND `selected`='0' GROUP BY id";
		$Result = $this->class->main->mysql->Query($Query);
		$Template = $this->class->main->mysql->FetchResults($Result);

		$Num = (int) $Template[0]['COUNT(*)'];
		if ($Num == 0)
			Functions::AdminError("No style exists for that ID, or it is set as default");
	
		$this->class->main->mysql->Query("UPDATE `" . PREFIX . "templates` SET `selected`='0'");
		$this->class->main->mysql->Query("UPDATE `" . PREFIX . "templates` SET `selected`='1' WHERE `id`='$id'");
		$this->class->main->mysql->Query("UPDATE `" . PREFIX . "settings` SET `value` = '" . $Template[0]['path'] . "' WHERE `identifier` = 'Template'");

		Functions::Redirect( 'Default style has been set', 'index.php?act=styles' );
		
	}

	function showcase_styles()
	{
		$Query = "SELECT * FROM `".PREFIX."templates` WHERE `selected`='1'";
		$Result = $this->class->main->mysql->Query($Query);
		$Row = $this->class->main->mysql->FetchResults($Result);
		$Row = $Row[0];

		$desc = file_get_contents("../" . $Row['path'] . "about.html");
		$desc .= "<br /><br /><a href='index.php?act=styles&do=editstyle&id=".$Row['id']."'>Edit</a>";

		$tableHTML = Functions::LoadTemplate("template1", array("desc" => $desc, "path" => $Row['path']));

		$aQuery = "SELECT * FROM `".PREFIX."templates` WHERE `selected`='0'";
		$aResult = $this->class->main->mysql->Query($aQuery);
		$Templates = $this->class->main->mysql->FetchResults($aResult);
		$atableHTML = null;

		foreach($Templates as $aRow)
		{
			$desc=file_get_contents("../".$aRow['path']."about.html").'<br /><br /><a href="index.php?act=styles&do=editstyle&id='.$aRow['id'].'">Edit</a> | <a href="index.php?act=styles&do=deletestyle&id='.$aRow['id'].'" onclick="return DeleteLink(\'Are you sure you want delete the style entitled '.$aRow['title'].'?\nThis action can not be undone.\');">Delete</a>';
			$atableHTML .= Functions::LoadTemplate("template2", array(
				"id"		=> $aRow['id'],
				"title"		=> $aRow['title'],
				"desc"		=> $desc,
				"path"		=> $aRow['path'],
			));
				
		}

		$rtn1 = Functions::LoadTemplate("template3", array("tableHTML" => $tableHTML, "atableHTML" => $atableHTML));
		$rtn = Functions::BuildSection("Manage Templates", $rtn1);

		return $rtn;

	}

}


?>